import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.jdbc.JdbcConnectionSource;
import com.j256.ormlite.support.ConnectionSource;

public class AccountApp {

    // we are using a MySQl database
    private final static String DATABASE_URL = "jdbc:mysql://localhost:3306/orm_lab?useUnicode=true";

    private Dao<Account, Integer> accountDao;

    public static void main(String[] args) throws Exception {
        // turn our static method into an instance of Main
        new AccountApp().doMain(args);
    }

    private void doMain(String[] args) throws Exception {
        ConnectionSource connectionSource = null;
        try {
            // create our data-source for the database
            connectionSource = new JdbcConnectionSource(DATABASE_URL, "root", "");
            // setup our  DAOs
            setupDao(connectionSource);
            // read, write and delete some data
            processData();

            System.out.println("\n\nIt seems to have worked\n\n");
        } finally {
            // destroy the data source which should close underlying connections
            if (connectionSource != null) {
                connectionSource.close();
            }
        }
    }

    /**
     * Read and write some example data.
     */
    private void processData() throws Exception {
        Console console1 = new Console();
        Service service1 = new Service(accountDao);
        boolean continueLoop = true;

        System.out.println("Welcome to the database");


        //while loop to control user input
        while(continueLoop) {
            int userInput = console1.getIntegerInput(console1.printMenu());

            switch (userInput) {
                case 1: service1.create(new Account(console1.inputAccountName(), console1.inputPassword()));
                        break;
                case 2: service1.read(console1.getID());
                        break;
                case 3: service1.updateID(new Account(console1.inputAccountName(), console1.inputPassword()), console1.getID());
                        break;
                case 4: service1.delete(console1.getID());
                        break;
                case 5: continueLoop = false;
                        break;

            }



        }
    }

    /**
     * Setup our  DAOs
     */
    private void setupDao(ConnectionSource connectionSource) throws Exception {

        accountDao = DaoManager.createDao(connectionSource, Account.class);

    }
}
